---------------------------------------------------------
-- bcd27seg
-- creacion 16/02/05
-- seg_out(6 downto 0)= abcdefg
---------------------------------------------------------

-----------------------------------------------------------
----- PACKAGE pk_bcd27seg
-----------------------------------------------------------
LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

PACKAGE pk_bcd27seg IS
   COMPONENT bcd27seg IS
   	PORT(
          bcd_in      : IN  STD_LOGIC_VECTOR(3 downto 0);
   		 seg_out    : OUT STD_LOGIC_VECTOR(6 downto 0)
   		);
   END COMPONENT;
END PACKAGE;

-----------------------------------------------------------
----- ENTITY bcd27seg
-----------------------------------------------------------
LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


ENTITY bcd27seg IS
   	PORT(
         bcd_in     : IN  STD_LOGIC_VECTOR(3 downto 0);
   		seg_out    : OUT STD_LOGIC_VECTOR(6 downto 0)
   		);
END bcd27seg;


ARCHITECTURE synth of bcd27seg IS

--constants

--                 "abcdefg"
CONSTANT cero  : std_logic_vector(6 DOWNTO 0):= "0000001";
CONSTANT uno	: std_logic_vector(6 DOWNTO 0):= "1001111";
CONSTANT dos	: std_logic_vector(6 DOWNTO 0):= "0010010";
CONSTANT tres	: std_logic_vector(6 DOWNTO 0):= "0000110";
CONSTANT cuatro: std_logic_vector(6 DOWNTO 0):= "1001100";
CONSTANT cinco	: std_logic_vector(6 DOWNTO 0):= "0100100";
CONSTANT seis	: std_logic_vector(6 DOWNTO 0):= "0100000";
CONSTANT siete	: std_logic_vector(6 DOWNTO 0):= "0001101";
CONSTANT ocho	: std_logic_vector(6 DOWNTO 0):= "0000000";
CONSTANT nueve	: std_logic_vector(6 DOWNTO 0):= "0000100";
CONSTANT err	: std_logic_vector(6 DOWNTO 0):= "1010101";


BEGIN
 
--***********
seg_decoder:
--***********
PROCESS (bcd_in)
BEGIN
   CASE bcd_in IS
      WHEN X"0" => 
         seg_out <= cero;
      WHEN X"1" => 
         seg_out <= uno;
      WHEN X"2" => 
         seg_out <= dos;
      WHEN X"3" => 
         seg_out <= tres; 
      WHEN X"4" => 
         seg_out <= cuatro;
      WHEN X"5" => 
         seg_out <= cinco;
      WHEN X"6" => 
         seg_out <= seis;
      WHEN X"7" => 
         seg_out <= siete;
      WHEN X"8" => 
         seg_out <= ocho;
      WHEN X"9" => 
         seg_out <= nueve;
		WHEN others =>
			seg_out <= err;
   END CASE;
  
END PROCESS;

END synth;

