---------------------------------------------------------

--
---------------------------------------------------------

-----------------------------------------------------------
----- package PK_COUNTER
-----------------------------------------------------------
LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

PACKAGE PK_COUNTER IS
   COMPONENT COUNTER IS
   	PORT(
         CLEAR_IN   : IN  STD_LOGIC;
   	   ENABLE_IN  : IN STD_LOGIC;
         CLK_IN     : IN STD_LOGIC;
         COUNT_OUT  : OUT STD_LOGIC_VECTOR(3 DOWNTO 0)
   	);
   END COMPONENT;
END PACKAGE;

-----------------------------------------------------------
----- ENTITY COUNTER
-----------------------------------------------------------
LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.MATH_REAL.ALL;

ENTITY COUNTER IS
   	PORT(
         CLEAR_IN   : IN  STD_LOGIC;
   	   ENABLE_IN  : IN STD_LOGIC;
         CLK_IN     : IN STD_LOGIC;
         COUNT_OUT  : OUT STD_LOGIC_VECTOR(3 DOWNTO 0)
   	);
END COUNTER;

ARCHITECTURE behav of COUNTER IS

-- Constants --------------------------------------

-- Signals ----------------------------------------
signal r_count : std_logic_vector(3 downto 0);

begin

counter_process : process(CLK_IN)
   begin
      if (CLK_IN'event and CLK_IN='1') then
         if (CLEAR_IN='1') then
            r_count <= "0000";
         elsif (ENABLE_IN='1') then
            if (r_count = "1001") then
               r_count <= "0000";
            else
               r_count <= r_count + 1;
            end if;   
         end if;   
      end if;
end process;   

COUNT_OUT <= r_count;

end behav;
