LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE work.PK_COUNTER.all;

ENTITY counter_tb IS
END counter_tb;

ARCHITECTURE behav of counter_tb IS

signal clk_i : std_logic := '0';
signal clr_i : std_logic := '0';
signal ena_i : std_logic := '0';
signal count_o : std_logic_vector(3 downto 0);

constant T : time := 20 ns;
constant td : time := 5 ns;

begin

   clk_i <= not clk_i after T/2;

   DUT : COUNTER port map (
      CLEAR_IN   => clr_i,
      ENABLE_IN  => ena_i,
      CLK_IN     => clk_i,
      COUNT_OUT  => count_o
   );

   stimulus: process
   begin

      wait for (4*T+ td);
      clr_i <= '1';
      wait for (T);
      clr_i <= '0';

      wait for (4*T);
      ena_i <= '1';
      wait for (16*T);
      ena_i <= '0';

      wait for (4*T);
      ena_i <= '1';
      wait for (8*T);
      clr_i <= '1';
      wait for (8*T);
      ena_i <= '0';
      clr_i <= '0';

      -- Testing complete
      wait;

   end process stimulus;


end behav;
