LIBRARY ieee ;
USE ieee.std_logic_1164.all;

ENTITY lab1_top_tb IS
END lab1_top_tb;

ARCHITECTURE behav of lab1_top_tb IS

COMPONENT LAB1_TOP IS
   	PORT(
		CLK50_IN   : IN STD_LOGIC;
        BUTTON1_IN : IN STD_LOGIC;
        BUTTON2_IN : IN STD_LOGIC;
        DISP_0     : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);
        DISP_1     : OUT STD_LOGIC_VECTOR(6 DOWNTO 0)
   	);
END COMPONENT;

signal clk_i  : std_logic := '0';
signal but1_i : std_logic := '1'; -- ena
signal but2_i : std_logic := '1'; -- clear
signal disp0_o : std_logic_vector(6 downto 0); --unidades
signal disp1_o : std_logic_vector(6 downto 0); --decenas 

constant T : time := 20 ns;
constant td : time := 5 ns;

begin

    clk_i <= not clk_i after T/2;

    DUT : LAB1_TOP port map (
        CLK50_IN    => clk_i,
        BUTTON1_IN  => but1_i,
        BUTTON2_IN  => but2_i,
        DISP_0      => disp0_o,
        DISP_1      => disp1_o
     );

     stimulus: process
     begin
  
        wait for (4*T+ td);
        but2_i <= '0';
        wait for (T);
        but2_i <= '1';
  
        wait for (4*T);
        but1_i <= '0';
        wait for (16*T);
        but1_i <= '1';
  
        wait for (4*T);
        but1_i <= '0';
        wait for (8*T);
        but2_i <= '0';
        wait for (8*T);
        but1_i <= '1';
        but2_i <= '1';
  
        -- Testing complete
        wait;
  
     end process stimulus;

end behav;
